#!/usr/bin/python
# -*- coding: utf-8 -*-

from random import randrange
import os,sys

def add_new_elem(m):
	f=False
	cnt=1
	while cnt<1000 and f==False:
		x=randrange(4)
		y=randrange(4)
		cnt+=1
		if m[x][y]==0:
			f=True
			m[x][y]=2
	return m,f

def print_matrix(matrix):
	txt=""
	for row in matrix:
		for c in row:
			txt+="\t" + str(c)
		txt+="\n"
	print txt

def move_up(m):
	for cc in range(4):
		cur_col=[]
		for cr in range(4):
			if m[cr][cc]>0: cur_col.append(m[cr][cc])
		for i in range(1,len(cur_col)):
			if cur_col[i]==cur_col[i-1]:
				cur_col[i]=0
				cur_col[i-1]*=2
		cur_col=[x for x in cur_col if x>0]
		cur_col+=[0]*(4-len(cur_col))
		for cr in range(4):
			m[cr][cc]=cur_col[cr]
	return m

def move_down(m):
	for cc in range(4):
		cur_col=[]
		for cr in range(4):
			if m[cr][cc]>0: cur_col.append(m[cr][cc])
		for i in range(len(cur_col)-1):
			if cur_col[i]==cur_col[i+1]:
				cur_col[i]=0
				cur_col[i+1]*=2
		cur_col=[x for x in cur_col if x>0]
		cur_col=[0]*(4-len(cur_col))+cur_col
		for cr in range(4):
			m[cr][cc]=cur_col[cr]
	return m

def move_left(m):
	for cr in range(4):
		cur_row=[]
		for cc in range(4):
			if m[cr][cc]>0: cur_row.append(m[cr][cc])
		for i in range(1,len(cur_row)):
			if cur_row[i]==cur_row[i-1]:
				cur_row[i]=0
				cur_row[i-1]*=2
		cur_row=[x for x in cur_row if x>0]
		cur_row+=[0]*(4-len(cur_row))
		for cc in range(4):
			m[cr][cc]=cur_row[cc]
	return m
def move_right(m):
	for cr in range(4):
		cur_row=[]
		for cc in range(4):
			if m[cr][cc]>0: cur_row.append(m[cr][cc])
		for i in range(len(cur_row)-1):
			if cur_row[i]==cur_row[i+1]:
				cur_row[i]=0
				cur_row[i+1]*=2
		cur_row=[x for x in cur_row if x>0]
		cur_row=[0]*(4-len(cur_row))+cur_row
		for cc in range(4):
			m[cr][cc]=cur_row[cc]
	return m

#init matrix
m=[[0 for x in range(4)] for x in range(4)]
continue_game=True
while continue_game==True:
	m,continue_game=add_new_elem(m)
	print_matrix(m)
	ans=sys.stdin.read(1)
	if ans=="u":
		m=move_up(m)
	elif ans=="d":
		m=move_down(m)
	elif ans=="l":
		m=move_left(m)
	else:
		m=move_right(m)
	os.system('clear')